import { computed } from 'vue-demi';
import { useRoute, useRouter } from 'vue-router';

function useRouteHash(defaultValue, { mode = 'replace', route = useRoute(), router = useRouter(), } = {}) {
    return computed({
        get() {
            var _a;
            return (_a = route.hash) !== null && _a !== void 0 ? _a : defaultValue;
        },
        set(v) {
            router[mode]({ hash: v });
        },
    });
}

function useRouteQuery(name, defaultValue, { mode = 'replace', route = useRoute(), router = useRouter(), } = {}) {
    return computed({
        get() {
            const data = route.query[name];
            if (data == null)
                return defaultValue !== null && defaultValue !== void 0 ? defaultValue : null;
            if (Array.isArray(data))
                return data.filter(Boolean);
            return data;
        },
        set(v) {
            router[mode]({ query: { [name]: v } });
        },
    });
}

export { useRouteHash, useRouteQuery };
