(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-demi'), require('vue-router')) :
  typeof define === 'function' && define.amd ? define(['exports', 'vue-demi', 'vue-router'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.VueUseRouter = {}, global.VueDemi, global.VueRouter));
}(this, (function (exports, vueDemi, vueRouter) { 'use strict';

  function useRouteHash(defaultValue, { mode = 'replace', route = vueRouter.useRoute(), router = vueRouter.useRouter(), } = {}) {
      return vueDemi.computed({
          get() {
              var _a;
              return (_a = route.hash) !== null && _a !== void 0 ? _a : defaultValue;
          },
          set(v) {
              router[mode]({ hash: v });
          },
      });
  }

  function useRouteQuery(name, defaultValue, { mode = 'replace', route = vueRouter.useRoute(), router = vueRouter.useRouter(), } = {}) {
      return vueDemi.computed({
          get() {
              const data = route.query[name];
              if (data == null)
                  return defaultValue !== null && defaultValue !== void 0 ? defaultValue : null;
              if (Array.isArray(data))
                  return data.filter(Boolean);
              return data;
          },
          set(v) {
              router[mode]({ query: { [name]: v } });
          },
      });
  }

  exports.useRouteHash = useRouteHash;
  exports.useRouteQuery = useRouteQuery;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
